// Code generated by ent, DO NOT EDIT.

package chat

import (
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

const (
	// Label holds the string label denoting the chat type in the database.
	Label = "chat"
	// FieldID holds the string denoting the id field in the database.
	FieldID = "id"
	// FieldText holds the string denoting the text field in the database.
	FieldText = "text"
	// FieldAttachment holds the string denoting the attachment field in the database.
	FieldAttachment = "attachment"
	// FieldAttachmentType holds the string denoting the attachment_type field in the database.
	FieldAttachmentType = "attachment_type"
	// FieldFrontendUUID holds the string denoting the frontend_uuid field in the database.
	FieldFrontendUUID = "frontend_uuid"
	// FieldCreatedAt holds the string denoting the created_at field in the database.
	FieldCreatedAt = "created_at"
	// FieldUpdatedAt holds the string denoting the updated_at field in the database.
	FieldUpdatedAt = "updated_at"
	// FieldDeletedAt holds the string denoting the deleted_at field in the database.
	FieldDeletedAt = "deleted_at"
	// FieldReplyTo holds the string denoting the reply_to field in the database.
	FieldReplyTo = "reply_to"
	// EdgeProfile holds the string denoting the profile edge name in mutations.
	EdgeProfile = "profile"
	// EdgeChatRoom holds the string denoting the chat_room edge name in mutations.
	EdgeChatRoom = "chat_room"
	// EdgeReplyToEdge holds the string denoting the reply_to_edge edge name in mutations.
	EdgeReplyToEdge = "reply_to_edge"
	// EdgeReplies holds the string denoting the replies edge name in mutations.
	EdgeReplies = "replies"
	// Table holds the table name of the chat in the database.
	Table = "chats"
	// ProfileTable is the table that holds the profile relation/edge.
	ProfileTable = "chats"
	// ProfileInverseTable is the table name for the Profile entity.
	// It exists in this package in order to avoid circular dependency with the "profile" package.
	ProfileInverseTable = "profiles"
	// ProfileColumn is the table column denoting the profile relation/edge.
	ProfileColumn = "profile_chats"
	// ChatRoomTable is the table that holds the chat_room relation/edge.
	ChatRoomTable = "chats"
	// ChatRoomInverseTable is the table name for the ChatRoom entity.
	// It exists in this package in order to avoid circular dependency with the "chatroom" package.
	ChatRoomInverseTable = "chat_rooms"
	// ChatRoomColumn is the table column denoting the chat_room relation/edge.
	ChatRoomColumn = "chat_room_chats"
	// ReplyToEdgeTable is the table that holds the reply_to_edge relation/edge.
	ReplyToEdgeTable = "chats"
	// ReplyToEdgeColumn is the table column denoting the reply_to_edge relation/edge.
	ReplyToEdgeColumn = "reply_to"
	// RepliesTable is the table that holds the replies relation/edge.
	RepliesTable = "chats"
	// RepliesColumn is the table column denoting the replies relation/edge.
	RepliesColumn = "reply_to"
)

// Columns holds all SQL columns for chat fields.
var Columns = []string{
	FieldID,
	FieldText,
	FieldAttachment,
	FieldAttachmentType,
	FieldFrontendUUID,
	FieldCreatedAt,
	FieldUpdatedAt,
	FieldDeletedAt,
	FieldReplyTo,
}

// ForeignKeys holds the SQL foreign-keys that are owned by the "chats"
// table and are not defined as standalone fields in the schema.
var ForeignKeys = []string{
	"chat_room_chats",
	"profile_chats",
}

// ValidColumn reports if the column name is valid (part of the table columns).
func ValidColumn(column string) bool {
	for i := range Columns {
		if column == Columns[i] {
			return true
		}
	}
	for i := range ForeignKeys {
		if column == ForeignKeys[i] {
			return true
		}
	}
	return false
}

var (
	// TextValidator is a validator for the "text" field. It is called by the builders before save.
	TextValidator func(string) error
	// DefaultCreatedAt holds the default value on creation for the "created_at" field.
	DefaultCreatedAt func() time.Time
	// DefaultUpdatedAt holds the default value on creation for the "updated_at" field.
	DefaultUpdatedAt func() time.Time
	// UpdateDefaultUpdatedAt holds the default value on update for the "updated_at" field.
	UpdateDefaultUpdatedAt func() time.Time
)

// Order defines the ordering method for the Chat queries.
type Order func(*sql.Selector)

// ByID orders the results by the id field.
func ByID(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldID, opts...).ToFunc()
}

// ByText orders the results by the text field.
func ByText(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldText, opts...).ToFunc()
}

// ByAttachment orders the results by the attachment field.
func ByAttachment(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldAttachment, opts...).ToFunc()
}

// ByAttachmentType orders the results by the attachment_type field.
func ByAttachmentType(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldAttachmentType, opts...).ToFunc()
}

// ByFrontendUUID orders the results by the frontend_uuid field.
func ByFrontendUUID(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldFrontendUUID, opts...).ToFunc()
}

// ByCreatedAt orders the results by the created_at field.
func ByCreatedAt(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldCreatedAt, opts...).ToFunc()
}

// ByUpdatedAt orders the results by the updated_at field.
func ByUpdatedAt(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldUpdatedAt, opts...).ToFunc()
}

// ByDeletedAt orders the results by the deleted_at field.
func ByDeletedAt(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldDeletedAt, opts...).ToFunc()
}

// ByReplyTo orders the results by the reply_to field.
func ByReplyTo(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldReplyTo, opts...).ToFunc()
}

// ByProfileField orders the results by profile field.
func ByProfileField(field string, opts ...sql.OrderTermOption) Order {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newProfileStep(), sql.OrderByField(field, opts...))
	}
}

// ByChatRoomField orders the results by chat_room field.
func ByChatRoomField(field string, opts ...sql.OrderTermOption) Order {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newChatRoomStep(), sql.OrderByField(field, opts...))
	}
}

// ByReplyToEdgeField orders the results by reply_to_edge field.
func ByReplyToEdgeField(field string, opts ...sql.OrderTermOption) Order {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newReplyToEdgeStep(), sql.OrderByField(field, opts...))
	}
}

// ByRepliesCount orders the results by replies count.
func ByRepliesCount(opts ...sql.OrderTermOption) Order {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborsCount(s, newRepliesStep(), opts...)
	}
}

// ByReplies orders the results by replies terms.
func ByReplies(term sql.OrderTerm, terms ...sql.OrderTerm) Order {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newRepliesStep(), append([]sql.OrderTerm{term}, terms...)...)
	}
}
func newProfileStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(ProfileInverseTable, FieldID),
		sqlgraph.Edge(sqlgraph.M2O, true, ProfileTable, ProfileColumn),
	)
}
func newChatRoomStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(ChatRoomInverseTable, FieldID),
		sqlgraph.Edge(sqlgraph.M2O, true, ChatRoomTable, ChatRoomColumn),
	)
}
func newReplyToEdgeStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(Table, FieldID),
		sqlgraph.Edge(sqlgraph.M2O, true, ReplyToEdgeTable, ReplyToEdgeColumn),
	)
}
func newRepliesStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(Table, FieldID),
		sqlgraph.Edge(sqlgraph.O2M, false, RepliesTable, RepliesColumn),
	)
}
